<template>
  <div class="container custom-style">
    <line-chart v-if="loaded" :chartdata="chartdata" :options="options" />
    <v-dialog v-model="displayDataFilter" width="290" persistent>
      <template v-slot:activator="{ on }">
        <v-btn color="secondary" width="310" class="ma-3" v-on="on">
          Set Date Filter
        </v-btn>
      </template>

      <v-card>
        <v-date-picker v-model="dates" range scrollable>
          <v-spacer />
          <v-btn text color="primary" @click="displayDataFilter = false">Cancel</v-btn>
          <v-btn text color="primary" @click="filterDates(dates)">OK</v-btn>
        </v-date-picker>
      </v-card>
    </v-dialog>
    <v-btn color="secondary" width="310" class="ma-3" @click="resetDate">Clear Date Filter</v-btn>
  </div>
</template>

<script>
import LineChart from './Chart.vue'

export default {
  name: 'LineChartContainer',
  components: { LineChart },
  data: () => ({
    loaded: false,
    chartdata: null,
    options: null,
    displayDataFilter: false,
    dates: []
  }),
  computed: {
    dateRangeText() {
      return this.dates.join(' ~ ')
    }
  },
  async mounted() {
    const dataset = await this.fetchReportData()

    this.chartdata = {
      datasets: [...dataset]
    }

    // this.chartdata = {
    //   datasets: [...dataset]
    // }

    this.options = {
      scales: {
        xAxes: [
          {
            type: 'time',
            time: {
              parser: 'YYYY-MM-DD',
              unit: 'day'
            }
          }
        ]
      },
      title: {
        display: true,
        text: 'Chart of expenses with tags'
      }
    }

    this.loaded = true
  },
  methods: {
    createColor: function(str) {
      let hash = 0
      for (let i = 0; i < str.length; i++) {
        hash = str.charCodeAt(i) + ((hash << 5) - hash)
      }
      let colour = '#'
      for (let i = 0; i < 3; i++) {
        const value = (hash >> (i * 8)) & 0xff
        colour += ('00' + value.toString(16)).substr(-2)
      }
      return colour
    },
    async fetchReportData() {
      const {
        data: { series }
      } = await this.$http.get('reports')

      const dataset = []

      for (const { label, data } of series) {
        data.forEach(({ x, y }, index) => {
          data[index] = { x, y: Math.abs(y) }
        })

        const backgroundColor = this.createColor(label)
        dataset.push({
          label,
          backgroundColor,
          data
        })
      }
      return dataset
    },
    async filterDates(dates) {
      const dataset = await this.fetchReportData()
      dates.sort()

      this.loaded = false

      this.chartdata = {
        labels: [dates[0], dates[1]],
        datasets: [...dataset]
      }

      console.log(this.chartdata)

      this.options = {
        scales: {
          xAxes: [
            {
              type: 'time',
              time: {
                parser: 'YYYY-MM-DD',
                unit: 'day'
              }
            }
          ]
        },
        title: {
          display: true,
          text: 'Chart of expenses with tags'
        }
      }

      this.loaded = true
      this.displayDataFilter = false
    },
    resetDate() {
      console.log(this.dates)

      // this.dates = []
      // this.fetchData()
    }
  }
}
</script>

<style scoped>
.custom-style {
  width: 45vw;
}
</style>
